# AddFunction\<T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, TResult>(IActionRegistration,string,System.Func

Method in [ActionRegistrationExtension](https://docs.yarnspinner.dev/3.1/api/csharp/yarn.unity/yarn.unity.actionregistrationextension)

## Summary

Add a new function that returns a value, so that it can be called from Yarn scripts.

```csharp
public static void AddFunction<T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, TResult>(this IActionRegistration registration, string name, System.Func<T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, TResult> implementation);
```

## Remarks

When this function has been registered, it can be called from your Yarn scripts like so:

```
<<if myFunction(1, 2) == true>>
myFunction returned true!
<<endif>>
```

The `call` command can also be used to invoke the function:

```
<<call myFunction(1, 2)>>
```

## Parameters

| Name                                                                                                                                 | Description                                                                |
| ------------------------------------------------------------------------------------------------------------------------------------ | -------------------------------------------------------------------------- |
| `string` name                                                                                                                        | The name of the function to add.                                           |
| `Func<T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, TResult>` implementation                                                              | The `System.Delegate` that should be invoked when this function is called. |
| [Yarn.Unity.IActionRegistration](https://docs.yarnspinner.dev/3.1/api/csharp/yarn.unity/yarn.unity.iactionregistration) registration |                                                                            |

## Type Parameters

| Name    | Description                 |
| ------- | --------------------------- |
| TResult | The result of the function. |

## See Also

* [Library](https://docs.yarnspinner.dev/3.1/api/csharp/yarn/yarn.library): A collection of functions that can be called from Yarn programs.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.yarnspinner.dev/3.1/api/csharp/yarn.unity/yarn.unity.actionregistrationextension/yarn.unity.actionregistrationextension.addfunction-11.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
